<template>
  <v-col>
    <v-sheet height="64">
      <v-toolbar
        flat
      >
        <v-btn
          outlined
          color="accent"
          class="mr-4"
          @click="setToday"
        >
          Hoy
        </v-btn>
        <v-btn
          fab
          color="accent"
          text
          small
          @click="prev"
        >
          <v-icon small>
            mdi-chevron-left
          </v-icon>
        </v-btn>
        <v-btn
          fab
          text
          color="accent"
          small
          @click="next"
        >
          <v-icon small>
            mdi-chevron-right
          </v-icon>
        </v-btn>
        <v-toolbar-title v-if="$refs.calendar">
          {{ $refs.calendar.title }}
        </v-toolbar-title>
      </v-toolbar>
    </v-sheet>
    <v-sheet height="600">
      <v-calendar
        ref="calendar"
        v-model="focus"
        color="accent"
        :now="today"
        :value="today"
        :events="events"
        :event-color="getEventColor"
        type="week"
      />
    </v-sheet>
  </v-col>
</template>

<script lang="ts">
import { Component, Ref, Vue } from 'vue-property-decorator'
import { DateHelpers } from '~/core/helpers/DateHelpers'
import { TurnosStore } from '~/store/TurnosStore'

@Component
export default class calendar extends Vue {
  @Ref('calendar') calendar;

  colors = ['blue', 'indigo', 'deep-purple', 'cyan', 'green', 'orange', 'grey darken-1']
  focus = ''

  get today () {
    return DateHelpers.getFechaHoy()
  }

  get events () {
    return TurnosStore.turnos.map((p) => {
      return {
        ...p,
        name: p.titulo,
        start: p.fecha + ' ' + p.hora_inicio,
        end: p.fecha + ' ' + p.hora_fin,
        color: this.colors[this.rnd(0, this.colors.length - 1)]
      }
    })
  }

  getEventColor (event) {
    return event.color
  }

  rnd (a, b) {
    return Math.floor((b - a + 1) * Math.random()) + a
  }

  setToday () {
    this.focus = ''
  }

  prev () {
    this.calendar.prev()
  }

  next () {
    this.calendar.next()
  }
}
</script>

<style lang="scss">

</style>
